#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCIndexPort.h"
#import "QCStructurePort.h"
#import "QCColorPort.h"

@interface MeshGenerator : QCPatch
{
    QCIndexPort *inputWidth;
	QCIndexPort	*inputHeight;
	QCColorPort	*inputColor;

	QCStructurePort	*outputMesh;
	unsigned int width, height;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end