#import "MeshGenerator.h"

@implementation MeshGenerator : QCPatch

+ (int)executionMode
{
	return 2;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	
	if(z)
	{
		width = 0;
		height = 0;
	}

	return z;
}


- (id)setup:(QCOpenGLContext *)context
{


	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{


}


- (void)enable:(QCOpenGLContext *)context
{


}
- (void)disable:(QCOpenGLContext *)context
{


}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	unsigned int x, y;
	
	if([inputWidth indexValue] > 0 && [inputHeight indexValue] > 0)
	{
		// this will save time, but omits color changes...
		//if([inputWidth indexValue] != width || [inputHeight indexValue] != height)
		{
			width = [inputWidth indexValue];
			height = [inputHeight indexValue];
		
			//NSLog(@"Generating %i x %i mesh...",width, height);
			NSMutableArray	*meshArray = [NSMutableArray arrayWithCapacity:(width+1)*(height+1)];
			
			for(y = 0; y <= height; ++y)
			{
				for(x = 0; x <= width; ++x)
				{
					QCStructure *vertex = [[QCStructure alloc] init];
					
					[vertex setMember:[NSNumber numberWithFloat: ((float)x)/width - 0.5] forKey:@"x"];
					[vertex setMember:[NSNumber numberWithFloat: ((float)y)/height - 0.5] forKey:@"y"];
					[vertex setMember:[NSNumber numberWithFloat: 0.0] forKey:@"z"];
					[vertex setMember:[NSNumber numberWithFloat: [inputColor redComponent]] forKey:@"r"];
					[vertex setMember:[NSNumber numberWithFloat: [inputColor greenComponent]] forKey:@"g"];
					[vertex setMember:[NSNumber numberWithFloat: [inputColor blueComponent]] forKey:@"b"];
					[vertex setMember:[NSNumber numberWithFloat: [inputColor alphaComponent]] forKey:@"a"];
					
					//NSLog(@"Made vertex structure: %@",vertex);
					
					[meshArray addObject:vertex];
					[vertex autorelease];
				}
			}
			
			QCStructure *meshStruct = [[QCStructure alloc] initWithMembers:meshArray keyPrefix:@"vertex_"];
			[meshStruct setMember:[NSNumber numberWithInt:width] forKey:@"width"];
			[meshStruct setMember:[NSNumber numberWithInt:height] forKey:@"height"];
			
			//NSLog(@"Struct: %@",meshStruct);
			
			[outputMesh setStructureValue:meshStruct];
			[meshStruct autorelease];
			//[meshArray autorelease];
		}
	}

	return YES;
}

@end
