#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCStructurePort.h"

@interface MeshRenderer : QCPatch
{
	QCStructurePort *inputStructure;
	QCBooleanPort	*inputWireFrame;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end