#import <OpenGL/gl.h>
#import <OpenGL/OpenGL.h>
#import "MeshRenderer.h"

@implementation MeshRenderer : QCPatch

+ (int)executionMode
{
	return 1;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	
	return z;
}


- (id)setup:(QCOpenGLContext *)context
{


	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{


}


- (void)enable:(QCOpenGLContext *)context
{


}
- (void)disable:(QCOpenGLContext *)context
{


}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	unsigned int x, y;
	unsigned int width, height;
	QCStructure *mesh = [inputStructure structureValue];
	
	if(mesh == nil)
		return YES;
	
	width = [[mesh memberForKey:@"width"] intValue];
	height = [[mesh memberForKey:@"height"] intValue];
	
	if(width <= 0 || height <= 0)
		return YES;
	
	CGLSetCurrentContext([context CGLContextObj]);
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);

	
	QCStructure *vertex;
	for(y = 0; y < height; ++y)
	{
		glBegin(GL_TRIANGLE_STRIP);
		//glBegin(GL_LINE_STRIP);
		for(x = 0; x < width; ++x)
		{
			/* top, bottom, for each columb. first index is 1+x (stupid structure constructor), then width+1+x, */
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
			vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x+1]];
			glColor4f(
				[[vertex memberForKey:@"r"] floatValue],
				[[vertex memberForKey:@"g"] floatValue],
				[[vertex memberForKey:@"b"] floatValue],
				[[vertex memberForKey:@"a"] floatValue]);
			glVertex3f(
				[[vertex memberForKey:@"x"] floatValue],
				[[vertex memberForKey:@"y"] floatValue],
				[[vertex memberForKey:@"z"] floatValue]);
		}
		glEnd();
	}
	
	if([inputWireFrame booleanValue])
	{
		for(y = 0; y < height; ++y)
		{
			for(x = 0; x < width; ++x)
			{
				// same as above, but start at 3, and end at 2 (2 extra points) to complete the wireframe
				/* top, bottom, for each columb. first index is 1+x (stupid structure constructor), then width+1+x, */
				glBegin(GL_LINE_STRIP);
				glColor4f(1.0,1.0,1.0,1.0);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+y*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x+1]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				vertex = [mesh memberForKey:[NSString stringWithFormat:@"vertex_%i",1+(y+1)*(width+1)+x]];
				glVertex3f(
					[[vertex memberForKey:@"x"] floatValue],
					[[vertex memberForKey:@"y"] floatValue],
					[[vertex memberForKey:@"z"] floatValue]);
				glEnd();
			}
		}
	}

	return YES;
}

@end
